<?php
// IMDb link transformer wordpress plugin
//
// (c) 2005-10 Prometheus group
// http://www.ikiru.ch/blog
//
// **********************************************************************
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
// *****************************************************************

/*
Plugin Name: IMDb link transformer
Plugin URI: http://www.ikiru.ch/blog/imdb-link-transformer-wordpress-plugin
Description: Transforms every movie's name tagged &lt;!--imdb--&gt; (...) &lt;!--/imdb--&gt; into a link to an internal <a href="http://www.imdb.com"><acronym title="internet movie database">imdb</acronym></a> popup. Can also display data related to the movie you write about either in a <a href="widgets.php">widget</a> or inside a post. Perfect for your movies reviews. Cache handling. Have a look to the <a href="admin.php?page=imdblt_options">options page</a>.
Version: 1.5
Author: Psykotik
Author URI: http://www.ikiru.ch/blog
*/ 

// Stop direct call
if(preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) { die('You are not allowed to call this page directly.'); }


require_once ('config.php');
require_once ('inc/functions.php');
require_once ('inc/widget.php');

if (class_exists("imdb_settings_conf")) {
	$imdb_ft = new imdb_settings_conf();
	$imdb_admin_values = $imdb_ft->get_imdb_admin_option();
	$imdb_widget_values = $imdb_ft->get_imdb_widget_option();
	$imdb_cache_values = $imdb_ft->get_imdb_cache_option();
}


// *********************
// ********************* Functions
// *********************


/**
1.- Replace <!--imdb--> tags inside the posts
**/

##### a) Looks for what is inside tags  <!--imdb--> ...  <!--/imdb--> and constructs a link to "popup.php"
function parse_imdb_tags($correspondances){
	global $imdb_admin_values;
    
	$correspondances = $correspondances[0];
	preg_match("/<!--imdb-->(.*?)<!--\/imdb-->/i", $correspondances, $link_parsed);

	// link construction

	if ($imdb_admin_values['imdbpopup_highslide'] == 1) { // highslide popup
	$link_parsed = "<span class=\"link-imdb\"><a class=\"highslide\" onclick=\"return hs.htmlExpand(this, { objectType: 'iframe', width: ".$imdb_admin_values[popupLarg].", objectWidth: ".$imdb_admin_values[popupLarg].", objectHeight: ".$imdb_admin_values[popupLong].", headingEval: 'this.a.innerHTML', headingText: '".ucwords(imdb_htmlize($link_parsed[1]))."', wrapperClassName: 'titlebar', src: '".$imdb_admin_values[imdbplugindirectory]."inc/popup.php?film=".imdb_htmlize($link_parsed[1])."' } );\" href=\"#\" title=\"".__('open a new window with IMDb informations', 'imdb')."\">".$link_parsed[1]."</a></span>";
	} else {						// classic popup
	$link_parsed = "<a class=\"link-imdb\" onclick=\"window.open('".$imdb_admin_values[imdbplugindirectory]."inc/popup.php?film="
    .imdb_htmlize($link_parsed[1])."', 'popup', 'resizable=yes, toolbar=0, scrollbars=yes, status=no, location=no, width=".$imdb_admin_values[popupLarg].", height=".$imdb_admin_values[popupLong].", top=5, left=5')\" title=\"".__('open a new window with IMDb informations', 'imdb')."\">".$link_parsed[1]."</a>";
	}

	return $link_parsed;
}

##### b) Replace  <!--imdb--> tags with links to "popup.php"
function imdb_linking($text) {
	$pattern = '/<!--imdb-->(.*?)<!--\/imdb-->/i';
	$text = preg_replace_callback($pattern,'parse_imdb_tags',$text);
	return $text;
}

/**
2.- Replace [imdblt]movieID[/imdblt] tags inside posts (as a automation of imdb_external_call function)
**/

##### a) Looks for what is inside tags [imdblt] .... [/imdblt] and include the movies data

function parse_imdb_tag_transform ($text) {
	global $imdb_admin_values, $wp_query;
	$imdballmeta[] = $text[1];
	return "<div class='imdbincluded'>".imdb_external_call($imdballmeta)."</div>";
}

##### b) Replace [imdblt] .... [/imdblt] tags with movies data
function imdb_tags_transform ($text) {
	$pattern = "'\[imdblt\](.*?)\[/imdblt\]'si";
	return preg_replace_callback($pattern, 'parse_imdb_tag_transform',$text);
}

/**
3.-  Add tags button <!--imdb--> <!--/imdb--> to writing admin page
**/

##### a) HTML part

function imdb_add_quicktag() { ?>
		<script language="JavaScript" type="text/javascript"><!--
		var toolbar = document.getElementById("ed_toolbar");
		var buttonNumber = 0;
		if(toolbar)
		{
<?php //-------------------- <!--imdb--> part  ?>
			document.getElementById("ed_toolbar").innerHTML += "<input type=\"button\" class=\"imdb_handler\" id=\"imdb_handler\" value=\"imdb\" onclick=\"edInsertTag(edCanvas, 6666); \" />";
			
			edButtons[6666] = 
			new edButton('imdb_handler'
				,'imdb'
				,'<!--imdb-->'
				,'<!--/imdb-->'
				,''
			);
		}
		//--></script>
<?php 
}

##### b) tinymce part (wysiwyg display)

function imdb_addbuttons() {
   // Don't bother doing this stuff if the current user lacks permissions
   if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
     return;
 
   // Add only in Rich Editor mode
   if ( get_user_option('rich_editing') == 'true') {
     add_filter("mce_external_plugins", "add_imdb_tinymce_plugin");
     add_filter('mce_buttons', 'register_imdb_button');
   }
}
function register_imdb_button($buttons) {
   array_push($buttons, "separator", "imdb");
   return $buttons;
}
// Load the TinyMCE plugin 
function add_imdb_tinymce_plugin($plugin_array) {
   $plugin_array['imdb'] = WP_PLUGIN_URL .'/imdb-link-transformer/tinymce/editor_plugin.js';
   return $plugin_array;
}

/**
4.- transforms movie's name in a way to be able to be searchable (ie "ô" becomes "&ocirc;") 
**/ 

function imdb_htmlize ($lien) {
    // a. quotes escape
    $lienhtmlize = addslashes($lien);      
    // b.converts db to html -> no more needed
    //$lienhtmlize = htmlentities($lienhtmlize,ENT_NOQUOTES,"UTF-8");
    // c. regular expression to convert all accents; weird function...
    $lienhtmlize = preg_replace('/&(?!#[0-9]+;)/s', '&amp;', $lienhtmlize);
    // d. turns spaces to "+", which allows titles including several words
    $lienhtmlize = str_replace(array(' '), array('+'), $lienhtmlize);
    
    return $lienhtmlize; 
}

/**
5.- Add the stylesheet & javascript to pages head
**/ 

##### a) outside admin part
function imdb_add_head_blog () {
	global $imdb_admin_values; ?>

<!-- Added by "Imdb link transformer" plugin -->
<?php if (file_exists (TEMPLATEPATH . "/imdb.css") ) { // an imdb.css exists inside theme folder, take it! ?>
<link rel="stylesheet" href="<?php bloginfo('stylesheet_directory'); ?>/imdb.css" type="text/css" media="screen" />
<?php } else { // no imdb.css exists in theme, add default one?>
<link rel="stylesheet" href="<?php echo $imdb_admin_values[imdbplugindirectory] ?>css/imdb.css" type="text/css" media="screen" />
<?php } 

// Highslide popup
if ($imdb_admin_values['imdbpopup_highslide'] == 1) { 
// wp_enqueue_script('imdblt-highslide-js', $imdb_admin_values[imdbplugindirectory] . "js/highslide/highslide-with-html.js");
// wp_enqueue_style('imdblt-highslide-css', $imdb_admin_values[imdbplugindirectory] . "css/highslide.css", '', '', 'screen'); ?>
<script type="text/javascript" src="<?php echo $imdb_admin_values[imdbplugindirectory] ?>js/highslide/highslide-with-html.js"></script>
<link rel="stylesheet" type="text/css" href="<?php echo $imdb_admin_values[imdbplugindirectory] ?>css/highslide.css" type="text/css" media="screen" />
<script type="text/javascript">
hs.graphicsDir = '<?php echo $imdb_admin_values[imdbplugindirectory] ?>js/highslide/graphics/';
hs.showCredits = false;
	hs.outlineType = 'custom';
	hs.easing = 'linearTween';
	hs.align = 'center';
	hs.useBox = true;
	hs.registerOverlay(
		{ html: '<div class=\"closebutton\" onclick=\"return hs.close(this)\" title=\"Close\"></div>',
		position: 'top right',
		useOnHtml: true, fade: 2 }
	);
</script>
<!--[if lt IE 7]>'
	<link rel="stylesheet" type="text/css" href="<?php echo $imdb_admin_values[imdbplugindirectory] ?>css/highslide-ie6.css" type="text/css" media="screen" />
<![endif]--><?php
}?>

<!-- /Added by "Imdb link transformer" plugin -->

<?php
}

##### b) admin part
function imdb_add_head_admin () {
	echo "\n<!-- Added by \"Imdb link transformer\" plugin -->\n";
	imdb_add_css_admin ();
	imdb_add_js_admin ();
	echo "\n<!-- /Added by \"Imdb link transformer\" plugin -->\n";
}
function imdb_add_css_admin() {
	global $imdb_admin_values;
	echo "<link rel=\"stylesheet\" href=\"".$imdb_admin_values[imdbplugindirectory]."css/imdb-admin.css\" type=\"text/css\" />\n";
	//wp_enqueue_style('imdb_css_admin', $imdb_admin_values[imdbplugindirectory] . "css/imdb-admin.css"); -- new way
}
function imdb_add_js_admin () {
	global $imdb_admin_values;
	echo "<script type=\"text/javascript\" src=\"".$imdb_admin_values[imdbplugindirectory]."js/un-active-boxes.js\" /></script>\n";
	echo "<script type=\"text/javascript\" src=\"".$imdb_admin_values[imdbplugindirectory]."js/movevalues-formselectboxes.js\" /></script>";
	// wp_enqueue_script('imdb_js_admin', $imdb_admin_values[imdbplugindirectory] . "js/un-active-boxes.js"); -- new way
	wp_enqueue_script('common'); // script needed for meta_boxes (ie, help.php)
	wp_enqueue_script('wp-lists'); // script needed for meta_boxes (ie, help.php)
	wp_enqueue_script('postbox'); // script needed for meta_boxes (ie, help.php)
} 

/**
6.- Add the admin menu
**/

if (!function_exists("imdb_admin_panel")) {
	function imdb_admin_panel() {
		global $imdb_ft, $imdb_admin_values;
		if (!isset($imdb_ft)) {
			return;
		}

		if (function_exists('add_options_page') && ($imdb_admin_values['imdbwordpress_bigmenu'] == 0 ) ) {
			add_options_page('IMDb link transformer Options', 'IMDb LT', 'administrator', 'imdblt_options', array(&$imdb_ft, 'printAdminPage'));

			// third party plugin
			add_filter('ozh_adminmenu_icon_imdblt_options', 'ozh_imdblt_icon');
		}
		if (function_exists('add_submenu_page') && ($imdb_admin_values['imdbwordpress_bigmenu'] == 1 ) ) {
			// big menu for many pages for admin sidebar
			/*
			add_menu_page('Menu Title', 'Menu Title', 10, 'main_menu', 'sub_menu_1_callback');
			add_submenu_page('main_menu', 'Sub Menu Title 1', 'Sub Menu Title 1', 10,  'main_menu' , 'sub_menu_1_callback');
			add_submenu_page('main_menu', 'Sub Menu Title 2', 'Sub Menu Title 2', 10, 'sub_menu' , 'sub_menu_2_callback');
			*/
			add_menu_page( 'IMDb LT Options', 'IMDb LT' , 8, 'imdblt_options', array(&$imdb_ft, 'printAdminPage'), $imdb_admin_values[imdbplugindirectory].'pics/imdb.gif');
			add_submenu_page( 'imdblt_options' , 'IMDb link transformer options page', 'General options', 8, 'imdblt_options');
			add_submenu_page( 'imdblt_options' , 'Widget & In post options page', 'Widget/In post options', 8, 'imdblt_options&subsection=widgetoption', array(&$imdb_ft, 'printAdminPage'));
			add_submenu_page( 'imdblt_options', 'Cache management options page', 'Cache management', 8, 'imdblt_options&subsection=cache', array(&$imdb_ft, 'printAdminPage'));
			add_submenu_page( 'imdblt_options' , 'Help page', 'Help', 8, 'imdblt_options&subsection=help', array(&$imdb_ft, 'printAdminPage'));
			//
		}
	
		if (function_exists('add_action') ) {
			// scripts & css
			add_action('admin_enqueue_scripts', 'imdb_add_head_admin');
			// buttons
			add_action('admin_footer', 'imdb_add_quicktag');
		}
	}
}	

/**
7.- Function for external calls (ie, inside a post)
**/

function imdb_external_call ($moviename="") {
global $imdb_admin_values, $imdb_widget_values, $wp_query;

	if (empty($moviename)) {	// compatibility with old function
	

	$filmid = $wp_query->post->ID;
	$imdballmeta = get_post_meta($filmid, 'imdb-movie-widget', false);
	echo "<div class='imdbincluded'>";
	include ( "inc/imdb-movie.inc.php" );
	echo "</div>";


	} else {			// new way to call function (using a parameter)
	$imdballmeta = $moviename;
	ob_start(); // start record
	echo "<div class='imdbincluded'>";
	include ( "inc/imdb-movie.inc.php" );
	echo "</div>";
	$out1 = ob_get_contents(); //put the record into value
	ob_end_clean(); // end record
	}

return $out1;
}

/**
8.- Add icon for Admin Drop Down Icons
* http://planetozh.com/blog/my-projects/wordpress-admin-menu-drop-down-css/
**/

function ozh_imdblt_icon() {
	global $imdb_admin_values;
	return $imdb_admin_values[imdbplugindirectory]. 'pics/imdb.gif';
}


// *********************
// ********************* Automatisms & executions
// *********************

// Be sure WP is running
if (function_exists('add_action')) {
    	// css for main blog
	add_action('wp_head', 'imdb_add_head_blog',3);

	// add links to popup
	add_filter('the_content', 'imdb_linking', 11);
	add_filter('the_excerpt', 'imdb_linking', 11);
    	// delete this one if you don't want IMDB link transformer to be run on comments
	add_filter('comment_text', 'imdb_linking', 11);

	// add data inside a post
	add_action('the_content', 'imdb_tags_transform', 11);

	// admin menu
	if (isset($imdb_ft)) {
		add_action('admin_menu', 'imdb_admin_panel');
		add_action('init', 'imdb_addbuttons');
	}
	
	// Widget
	add_action('plugins_loaded', 'register_imdbwidget');
}

?>
